# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/ajinabraham/njsscan/blob/master/njsscan/rules/semantic_grep/jwt/jwt_not_revoked.yaml
# hash: e7a0a61
# yamllint enable
---
rules:
- id: "rules_lgpl_javascript_jwt_rule-jwt-not-revoked"
  patterns:
  - pattern-inside: |
      $JWT = require('express-jwt')
      ...
  - pattern: "$JWT(...)"
  - pattern-not-inside: |-
      $JWT(<... {isRevoked:...} ...>,...)
  - pattern-not-inside: |-
      $OPTS = <... {isRevoked:...} ...>;
      ...
      $JWT($OPTS,...)
  message: |
    No token revoking configured for `express-jwt`. A leaked token could still be used and unable to be revoked. Consider using function as the `isRevoked` option.
  severity: "WARNING"
  languages:
  - "javascript"
  metadata:
    owasp: 
    - "A3:2017-Sensitive Data Exposure"
    - "A02:2021-Cryptographic Failures"
    cwe: "CWE-522"
    shortDescription: "Insufficiently protected credentials"
    security-severity: "HIGH"
    category: "security"
